=== debian/changelog ===
vimix (0.8.4+git20250220+ds-2build1) questing; urgency=medium

  * No-change rebuild for libtinyxml2-11.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 04 May 2025 11:26:51 +0100

vimix (0.8.4+git20250220+ds-2) unstable; urgency=medium

  * Team upload
  * Workaround broken system FindGStreamer.cmake (Closes: #1100327)
  * Fix FTBFS due to missing #include <algorithm>

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 27 Mar 2025 19:14:28 +0800

vimix (0.8.4+git20250220+ds-1) unstable; urgency=medium

  * New upstream version. (Closes: #1075621)
  * d/rules: set FETCHCONTENT_FULLY_DISCONNECTED.
  * d/patches: dropped.

 -- Alex Myczko <tar@debian.org>  Thu, 20 Feb 2025 11:13:35 +0000

vimix (0.7.2+git20221123+ds-3) unstable; urgency=medium

  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Mon, 22 Jul 2024 20:35:48 +0000
