## vimix 0.8.5c+git20251123+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -103,6 +103,30 @@
             ${X11_INCLUDE_DIR}
         )
 
+        # XInput2 for tablet pressure support (optional)
+        find_package(X11 COMPONENTS Xi)
+        if(X11_Xi_FOUND)
+            add_definitions(-DHAVE_X11TABLETINPUT)
+            macro_log_feature(X11_Xi_FOUND "XInput2" "X11 Input extension for tablet support" "https://www.x.org/wiki/" FALSE)
+        else()
+       
+            # alternatively libinput and libudev for tablet pressure support
+            if (PKG_CONFIG_FOUND)
+                pkg_check_modules(LIBINPUT libinput>=1.19)
+                pkg_check_modules(LIBUDEV libudev)
+            endif()
+
+            if(LIBINPUT_FOUND AND LIBUDEV_FOUND)
+                include_directories(${LIBINPUT_INCLUDE_DIRS} ${LIBUDEV_INCLUDE_DIRS})
+                link_directories(${LIBINPUT_LIBRARY_DIRS} ${LIBUDEV_LIBRARY_DIRS})
+                add_definitions(-DHAVE_LIBINPUT)
+                macro_log_feature(LIBINPUT_FOUND "libinput" "Input device library for tablet support" "https://wayland.freedesktop.org/libinput" FALSE)
+                macro_log_feature(LIBUDEV_FOUND "libudev" "Device management library" "https://www.freedesktop.org/software/systemd/man/libudev.html" FALSE)
+            else()
+                message(STATUS "XInput2 (Xi) or libinput or libudev not found - tablet pressure support will be disabled")
+            endif()
+        endif()
+
     endif()
     add_definitions(-DUNIX)
 elseif(WIN32)
@@ -127,52 +151,74 @@
 #
 set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
 find_package(Threads REQUIRED)
-
 find_package(ZLIB REQUIRED)
 
 #
 # GSTREAMER
 #
-find_package(GLIB2 REQUIRED)
-macro_log_feature(GLIB2_FOUND "GLib" "GTK general-purpose utility library" "http://www.gtk.org" TRUE)
-
-find_package(GObject REQUIRED)
-macro_log_feature(GOBJECT_FOUND "GObject" "GTK object-oriented framework" "http://www.gtk.org" TRUE)
-
-find_package(GStreamer 1.0.0 COMPONENTS base)
-macro_log_feature(GSTREAMER_FOUND "GStreamer"
-"Open Source Multiplatform Multimedia Framework"
-"http://gstreamer.freedesktop.org/" TRUE "1.0.0")
-
-find_package(GStreamerPluginsBase 1.0.0 COMPONENTS app audio video pbutils gl)
-macro_log_feature(GSTREAMER_APP_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer app library"
-"http://gstreamer.freedesktop.org/" TRUE "1.0.0")
-
-macro_log_feature(GSTREAMER_AUDIO_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer audio library"
-"http://gstreamer.freedesktop.org/" TRUE "1.0.0")
-
-macro_log_feature(GSTREAMER_VIDEO_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer video library"
-"http://gstreamer.freedesktop.org/" TRUE "1.0.0")
-
-macro_log_feature(GSTREAMER_PBUTILS_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer pbutils library"
-"http://gstreamer.freedesktop.org/" TRUE "1.0.0")
-
-macro_log_feature(GSTREAMER_GL_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer opengl library"
-"http://gstreamer.freedesktop.org/" TRUE "1.0.0")
+if (PKG_CONFIG_FOUND)
+    pkg_check_modules(GSTREAMER REQUIRED gstreamer-base-1.0>=1.24
+        gstreamer-pbutils-1.0
+        gstreamer-app-1.0
+        gstreamer-audio-1.0
+        gstreamer-video-1.0
+        gstreamer-gl-1.0
+    )
+
+    include_directories(
+        ${GSTREAMER_INCLUDE_DIRS}
+    )
+
+    link_directories(
+        ${GSTREAMER_LIBRARY_DIRS}
+    )
+
+else ()
+    find_package(GLIB2 REQUIRED)
+    macro_log_feature(GLIB2_FOUND "GLib" "GTK general-purpose utility library" "http://www.gtk.org" TRUE)
+
+    find_package(GObject REQUIRED)
+    macro_log_feature(GOBJECT_FOUND "GObject" "GTK object-oriented framework" "http://www.gtk.org" TRUE)
+
+    find_package(GStreamer 1.0 COMPONENTS base REQUIRED)
+
+    find_package(GStreamerPluginsBase 1.0.0 COMPONENTS app audio video pbutils gl)
+    macro_log_feature(GSTREAMER_APP_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer app library"
+    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
+    macro_log_feature(GSTREAMER_AUDIO_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer audio library"
+    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
+    macro_log_feature(GSTREAMER_VIDEO_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer video library"
+    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
+    macro_log_feature(GSTREAMER_PBUTILS_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer pbutils library"
+    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
+    macro_log_feature(GSTREAMER_GL_LIBRARY_FOUND "GStreamerPluginsBase" "GStreamer opengl library"
+    "http://gstreamer.freedesktop.org/" TRUE "1.0.0")
+
+    include_directories(
+        ${GLIB2_INCLUDE_DIR}
+        ${GSTREAMER_INCLUDE_DIR}
+        ${GSTREAMER_AUDIO_INCLUDE_DIR}
+        ${GSTREAMER_VIDEO_INCLUDE_DIR}
+        ${GSTREAMER_BASE_INCLUDE_DIR}
+        ${GSTREAMER_APP_INCLUDE_DIR}
+        ${GSTREAMER_PBUTILS_INCLUDE_DIR}
+        ${GSTREAMER_GL_INCLUDE_DIR}
+    )
+    set( GSTREAMER_LIBRARIES
+        ${GOBJECT_LIBRARIES}
+        ${GSTREAMER_BASE_LIBRARY}
+        ${GSTREAMER_APP_LIBRARY}
+        ${GSTREAMER_AUDIO_LIBRARY}
+        ${GSTREAMER_VIDEO_LIBRARY}
+        ${GSTREAMER_PBUTILS_LIBRARY}
+        ${GSTREAMER_GL_LIBRARY}
+    )
+
+endif ()
+
 
 # Various preprocessor definitions for GST
 add_definitions(-DGST_DISABLE_XML -DGST_DISABLE_LOADSAVE)
-
-include_directories(
-    ${GLIB2_INCLUDE_DIR}
-    ${GSTREAMER_INCLUDE_DIR}
-    ${GSTREAMER_AUDIO_INCLUDE_DIR}
-    ${GSTREAMER_VIDEO_INCLUDE_DIR}
-    ${GSTREAMER_BASE_INCLUDE_DIR}
-    ${GSTREAMER_APP_INCLUDE_DIR}
-    ${GSTREAMER_PBUTILS_INCLUDE_DIR}
-    ${GSTREAMER_GL_INCLUDE_DIR}
-)
 
 #
 # ICU4C
@@ -333,61 +379,3 @@
             HINTS ${SHMDATA_LIBRARY_DIRS}/gstreamer-1.0
         )
         if(GSTREAMER_SHMDATA_LIBRARY)
-            add_definitions(-DGSTREAMER_SHMDATA_PLUGIN=\"${GSTREAMER_SHMDATA_LIBRARY}\")
-        endif()
-
-        macro_log_feature(GSTREAMER_SHMDATA_LIBRARY "GStreamerPluginShmdata" "Plugin to share any flow" "https://gitlab.com/sat-mtl/tools/shmdata" FALSE)
-    endif(SHMDATA_FOUND)
-
-endif(UNIX)
-
-
-# show message about found libs
-macro_display_feature_log()
-
-#####
-##### Locally built libraries
-#####
-
-#
-# GLAD
-#
-set(GLAD_LIBRARIES GLAD)
-set(GLAD_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/ext/glad/include)
-include_directories(
-    ${GLAD_INCLUDE_DIRS}
-)
-add_library(GLAD "${CMAKE_CURRENT_SOURCE_DIR}/ext/glad/src/glad.c")
-set_property(TARGET GLAD PROPERTY C_STANDARD 11)
-message(STATUS "Compiling 'GLAD 2' Open source multi-language OpenGL loader https://gen.glad.sh -- ${GLAD_INCLUDE_DIRS}")
-
-#
-# DEAR IMGUI
-#
-set(IMGUI_LIBRARIES IMGUI IMGUITEXTEDIT)
-set(IMGUI_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/ext/imgui)
-set(IMGUI_BACKEND_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/ext/imgui/examples)
-include_directories(
-    ${IMGUI_INCLUDE_DIRS}
-    ${IMGUI_BACKEND_INCLUDE_DIRS}
-)
-set(IMGUI_SRCS
-    ${CMAKE_CURRENT_SOURCE_DIR}/ext/imgui/imgui.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/ext/imgui//imgui_demo.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/ext/imgui//imgui_draw.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/ext/imgui//imgui_widgets.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/ext/imgui/examples/imgui_impl_glfw.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/ext/imgui/examples/imgui_impl_opengl3.cpp
-    )
-add_library(IMGUI "${IMGUI_SRCS}")
-target_compile_definitions(IMGUI PRIVATE "IMGUI_IMPL_OPENGL_LOADER_GLAD")
-target_compile_definitions(IMGUI PRIVATE "IMGUI_USE_STB_SPRINTF")
-message(STATUS "Compiling 'Dear ImGui' from https://github.com/ocornut/imgui.git -- ${IMGUI_INCLUDE_DIRS}")
-
-#
-# ImGui Color Text Editor
-#
-set(IMGUITEXTEDIT_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ext/ImGuiColorTextEdit)
-include_directories(
-    ${IMGUITEXTEDIT_INCLUDE_DIR}
-)
