=== src/CMakeLists.txt ===
--- 
+++ 
@@ -102,11 +102,35 @@
     Playlist.cpp
     Audio.cpp
     TextSource.cpp
+    ShaderSource.cpp
+    TabletInput.cpp
 )
 
 #####
 ##### DEFINE THE TARGET (OS specific)
 #####
+
+IF(APPLE)
+
+    # Add macOS tablet input implementation
+    list(APPEND VMIX_SRCS ${CMAKE_SOURCE_DIR}/osx/TabletInput_macos.mm)
+    # Enable Objective-C++
+    set_source_files_properties(${CMAKE_SOURCE_DIR}/osx/TabletInput_macos.mm PROPERTIES COMPILE_FLAGS "-x objective-c++")
+
+ELSE(APPLE)
+
+    # Add Linux tablet input implementation
+    if(X11_Xi_FOUND)
+        # Use X11/XInput2 version (works in Flatpak and everywhere)
+        list(APPEND VMIX_SRCS TabletInput_x11.cpp)
+    else()
+        if(LIBINPUT_FOUND AND LIBUDEV_FOUND)
+            # Use X11/XInput2 version (works in Flatpak and everywhere)
+            list(APPEND VMIX_SRCS TabletInput_linux_libinput.cpp)
+        endif()
+    endif()
+
+ENDIF(APPLE)
 
 IF(APPLE)
 
@@ -147,6 +171,16 @@
         X11::X11
         X11::xcb
     )
+
+    # Add XInput2 library for tablet support on Linux (if available)
+    if(X11_Xi_FOUND)
+        list(APPEND PLATFORM_LIBS ${X11_Xi_LIB})
+    endif()
+
+    # Add libinput and libudev for tablet support on Linux (if available)
+    if(LIBINPUT_FOUND AND LIBUDEV_FOUND)
+        list(APPEND PLATFORM_LIBS ${LIBINPUT_LIBRARIES} ${LIBUDEV_LIBRARIES})
+    endif()
 
 ENDIF(APPLE)
 
@@ -170,14 +204,7 @@
     ${TINYXML2_LIBRARIES}
     ${ICU_LIBRARIES}
     ${CMAKE_DL_LIBS}
-    ${GOBJECT_LIBRARIES}
-    ${GSTREAMER_LIBRARY}
-    ${GSTREAMER_BASE_LIBRARY}
-    ${GSTREAMER_APP_LIBRARY}
-    ${GSTREAMER_AUDIO_LIBRARY}
-    ${GSTREAMER_VIDEO_LIBRARY}
-    ${GSTREAMER_PBUTILS_LIBRARY}
-    ${GSTREAMER_GL_LIBRARY}
+    ${GSTREAMER_LIBRARIES}
     Threads::Threads
     ZLIB::ZLIB
     Ableton::Link
