=== debian/changelog ===
vimix (0.8.5c+git20251123+ds-1build1) resolute; urgency=medium

  * No-change rebuild for icu soname.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 02 Dec 2025 22:50:39 +0100

vimix (0.8.5c+git20251123+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Sun, 23 Nov 2025 21:24:43 +0100
